routes/web.php
<?php

use App\Http\Controllers\BookController;
use App\Http\Controllers\BorrowController;
use App\Http\Controllers\GenreController;
use Illuminate\Support\Facades\Route;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Input;
use Illuminate\Http\Request;

use App\Models\Book;
use App\Models\User;
use App\Models\Genre;
use App\Models\Borrow;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    $user_count = User::count();
    $book_count = Book::count();
    $genre_count = Genre::count();
    $accepted_borrow_count = Borrow::active_rentals()->count();
    $genres = Genre::all();

    return view('index', [
        'user_count' => $user_count,
        'book_count' => $book_count,
        'genre_count' => $genre_count,
        'accepted_borrow_count' => $accepted_borrow_count,
        'genres' => $genres
    ]);
});

Route::resource('books', BookController::class);
Route::resource('genres', GenreController::class);
Route::resource('borrows', BorrowController::class);

Route::get('/user/rentals', function() {
    $user = Auth::user();

    $b_pending = Borrow::where('reader_id', $user['id'])->
                         where('status', 'PENDING')->
                         get();

    $b_intime = Borrow::where('reader_id', $user['id'])->
                        where('status', 'ACCEPTED')->
                        where('deadline', '>=', now())->
                        get();

    $b_overdue = Borrow::where('reader_id', $user['id'])->
                         where('status', 'ACCEPTED')->
                         where('deadline', '<', now())->
                         get();

    $b_rejected = Borrow::where('reader_id', $user['id'])->
                          where('status', 'REJECTED')->
                          get();

    $b_returned = Borrow::where('reader_id', $user['id'])->
                          where('status', 'RETURNED')->
                          get();

    return view('borrow.user', [
        'b_pending' => $b_pending,
        'b_intime' => $b_intime,
        'b_overdue' => $b_overdue,
        'b_rejected' => $b_rejected,
        'b_returned' => $b_returned,
    ]);
})->middleware('auth');

Route::get('/profile', function() {
    $user = Auth::user();
    if (!$user) {
        return abort(403);
    }

    return view('profile', [
        'user' => $user
    ]);
});

Auth::routes();

Route::get('/logout', '\App\Http\Controllers\Auth\LoginController@logout');

resources/views/index.blade.php
@extends('layouts.general')

@section('title', 'Index Test')

@section('content')

{{-- https://getbootstrap.com/docs/5.0/layout/containers/ --}}
<div class="container-sm">
    <h2 class="mt-5">Stats:</h2>
    <div class="list-group">

        <span class="list-group-item list-group-item-primary">
            Users: <strong>{{ $user_count }}</strong>
        </span>
        <span class="list-group-item list-group-item-secondary">
            Books: <strong>{{ $book_count }}</strong>
        </span>
        <span class="list-group-item list-group-item-primary">
            Genres: <strong>{{ $genre_count }}</strong>
        </span>
        <span class="list-group-item list-group-item-secondary">
            Acrive Rentals: <strong>{{ $accepted_borrow_count }}</strong>
        </span>

    </div>

    <h2 class="mt-5">Genres:</h2>
    @include('components.genrelist', ['genres' => $genres])

    <h2 class="mt-5">Search:</h2>
    <form action="{{ route('books.index') }}">
        <input type="text" name="q" class="form-control">
        <input type="submit" class="form-control" value="Search">
    </form>
</div>

@endsection

resources/views/profile.blade.php
@extends('layouts.general')
@section('title', 'User Profile')
@section('content')

<div class="container-sm">
    <h1 class="mt-5">My Profile</h1>

    <table class="table">
        <tr>
            <td>Name</td>
            <td>{{ $user['name'] }}</td>
        </tr>
        <tr>
            <td>Email</td>
            <td>{{ $user['email'] }}</td>
        </tr>
        <tr>
            <td>Role</td>
            <td>{{ $user['is_librarian'] ? 'Librarian' : 'Reader' }}</td>
        </tr>
    </table>
</div>

@endsection